import java.io.*;

/* simple LL(1) parser for the grammar :   */
/* F -> a    S -> F     S -> (F+S)         */
class Parser {

    protected LookAhead1Reader reader;

    public Parser(LookAhead1Reader r) {
	reader=r;
    }

    public void term (char c) throws IOException, ReadException {
	/* consume the character c */
	reader.eat(c);
    }

    public void nonterm_S()
	throws IOException, IllegalArgumentException,
	       ReadException, ParserException {
	/* parse a word generated from nonterminal S */
	if (reader.check('a')) {
	    this.nonterm_F();
	} else if (reader.check('(')) {
	    this.term('(');
	    this.nonterm_F();
	    this.term('+');
	    this.nonterm_S();
	    this.term(')');
	} else {
	    throw new ParserException("cannot reduce S");
	}
    }

    public void nonterm_F() throws IOException, ReadException {
	/* parse a word generated from nonterminal F */
	this.term('a');
    }
}
